<template>
  <div>
    <Drawer
      :title="formTitle"
      v-model="modalVisible"
      width="720"
      :mask-closable="false"
      :styles="styles"
      @on-close="close"
    >
      <Form
        ref="formValidate"
        :model="formValidate"
        :rules="ruleValidate"
        :label-width="150"
      >
       <FormItem label="广告名称" prop="title">
          <Input
            v-model="formValidate.title"
            placeholder="Enter something"
          ></Input>
        </FormItem>
        <FormItem label="广告倒计时" prop="countdown">
         <InputNumber v-model="formValidate.countdown"></InputNumber>
        </FormItem>
         <FormItem label="slogen" prop="slogen">
          <Input
            v-model="formValidate.slogen"
            placeholder="Enter something"
          ></Input>
        </FormItem>
         <FormItem label="广告图片" prop="res_show_pic">
           <UploadS ref="res_show_pic" v-model="formValidate.res_show_pic" />
        </FormItem>
      </Form>
      <div class="demo-drawer-footer">
        <Button style="margin-right: 8px" @click="close">取消</Button>
        <Button type="primary" @click="submit">保存</Button>
      </div>
    </Drawer>
  </div>
</template>
<script>
import UploadS from '@/view/common/upload.vue'
import {
  addAdvertisements,
  editAdvertisements
} from '@/api/advertisement'
import {
  getTreeCategories
} from '@/api/categories'
const _requireBlur = { required: true, message: ' ', trigger: 'blur' }
const validatorPic = (rule, value, callback) => {
  if (!value) {
    callback(new Error(' '))
  } else {
    callback()
  }
}
const _requirePic = { required: true, message: ' ', trigger: 'blur', validator: validatorPic }
export default {
  props: {
    search: {
      type: Function,
      default: null
    },
    treeData: {
      type: Array,
      default: () => []
    },
    row: {
      type: Object,
      default: () => {}
    },
    visible: {
      type: Boolean,
      default: false
    }
  },
  components: {
    UploadS
  },
  data () {
    return {
      modalVisible: false,
      editMode: false,
      formTitle: '',
      styles: {
        height: 'calc(100% - 55px)',
        overflow: 'auto',
        paddingBottom: '53px',
        position: 'static'
      },
      formValidate: {},
      ruleValidate: {
        'title': [_requireBlur],
        'slogen': [_requireBlur],
        'countdown': [_requirePic],
        'res_show_pic': [_requirePic]
      }
    }
  },
  watch: {
    visible: {
      handler: function (val) {
        this.modalVisible = val
        if (val) {
          this.search()
        }
        this.formValidate = this.row
      },
      immediate: true
    },
    row: {
      handler: function (val) {
        console.log(val)
        if (val.id === 'add') {
          this.editMode = false
          this.formTitle = '新增首页广告'
          this.formValidate = {
            title: '',
            countdown: 0,
            slogen: '',
            res_show_pic: ''
          }
        } else {
          this.editMode = true
          this.formTitle = '编辑首页广告'
          this.formValidate = val
        }
      },
      immediate: true
    }
  },
  methods: {
    submit () {
      let res_show_pic = this.$refs['res_show_pic'].getData()
      if (res_show_pic) {
        this.formValidate.res_show_pic = res_show_pic
      }
      this.$refs['formValidate'].validate((valid) => {
        if (valid) {
          delete this.formValidate.created_at
          delete this.formValidate.deleted_at
          delete this.formValidate.updated_at
          let params = [this.formValidate]
          if (this.editMode) {
            editAdvertisements(params).then((res) => {
              if (res.code === 200 && res.data.length > 0) {
                this.$Message.success('修改成功')
                this.close()
                this.search()
              }
            })
          } else {
            addAdvertisements(params).then((res) => {
              if (res.code === 200 && res.data.length > 0) {
                this.$Message.success('新增成功')
                this.close()
                this.search()
              }
            })
          }
        } else {
          this.$Message.error('您还有必填项未填写')
        }
      })
    },
    getTree (e) {
      getTreeCategories(e).then((res) => {
        console.log(res)
      })
    },
    change (val, type) {
      if (type === 1) {
        this.formValidate.is_in_home_lis = val ? 1 : 0
      }
      if (type === 2) {
        this.formValidate.is_in_discover_list = val ? 1 : 0
      }
    },
    close () {
      this.$emit('update:visible', false)
    }
  }
}
</script>
<style>
.demo-drawer-footer {
  width: 100%;
  position: absolute;
  bottom: 0;
  left: 0;
  border-top: 1px solid #e8e8e8;
  padding: 10px 16px;
  text-align: right;
  background: #fff;
}
</style>
